﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ReplaceUIDs
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.Cancel)
                return;
            string filename = openFileDialog1.FileName;
            string fileText = System.IO.File.ReadAllText(filename);
            string excludeGuids = System.IO.File.ReadAllText("excludeUIDs.txt");
            Regex myReg = new Regex("\\w{8}-\\w{4}-\\w{4}-\\w{4}-\\w{12}");
            MatchCollection foundGUIDs = myReg.Matches(fileText);
            MatchCollection foundExcludeGUIDs = myReg.Matches(excludeGuids);

            Dictionary<string, string> replaceDict = new Dictionary<string, string>();
            HashSet<string> GUIDs = new HashSet<string>();
            HashSet<string> ExcludeGUIDs = new HashSet<string>();

            foreach (Match m in foundGUIDs) {
                GUIDs.Add(m.Value);
            }

            foreach (Match m in foundExcludeGUIDs)
            {
                ExcludeGUIDs.Add(m.Value);
            }

            foreach (String h in GUIDs)
            {
                replaceDict.Add(h, Guid.NewGuid().ToString());
            }

            bool skipStep = false;

            foreach (KeyValuePair<string, string> kvp in replaceDict)
            {
                foreach (String h in ExcludeGUIDs)
                {
                    if(kvp.Key.ToUpper() == h.ToUpper())
                    {
                        skipStep = true;
                    }

                }
                if (skipStep == false)
                {
                    fileText = fileText.Replace(kvp.Key, kvp.Value);
                }
                skipStep = false;

            }

            List<string> lines = new List<string>();
            lines = fileText.Split('\n').ToList();
            bool repFlag = false;
            string postfix = "";

            if (textBox1.Text != "")
            {
                postfix = "_" + textBox1.Text;
            }

            for (int i = 0; i < lines.Count(); i++)
            {

                if (lines[i].Contains("GENERIC_REPORT_FOR_USER") || lines[i].Contains("GENERIC_REPORT") || lines[i].Contains("GR_COMMON_GENERATOR"))
                {
                    repFlag = true;
                }

                if (lines[i].Contains("GENERIC_REPORT_GROUPBY") || lines[i].Contains("GENERATOR_LINK") || lines[i].Contains("GENERIC_REPORT_MAIN_ITEM") || lines[i].Contains("STATIC_GROUPS"))
                {
                    repFlag = false;
                }

                if (repFlag == true && lines[i].Contains("&lt;bo:Attr Name=\"Name\""))
                {

                    lines[i] = lines[i].Substring(0, lines[i].Length - 17) + postfix + "&lt;/bo:Attr&gt;";
                }
            }




            MessageBox.Show("Замена произведена, сохраните файл");

            saveFileDialog1.FileName = System.IO.Path.GetFileName(filename);
            if (saveFileDialog1.ShowDialog() == DialogResult.Cancel)
                return;

            
            string filenameSave = saveFileDialog1.FileName;

            string result = String.Join("\n", lines);

            System.IO.File.WriteAllText(filenameSave, result);
            MessageBox.Show("Файл сохранен");



        }


    }
}
